export function strictEqual(a, b) {
  return a === b;
}
export function shallowEqual(a, b) {
  return strictEqual(a, b) || bothObjects(a, b) && equalProps(a, b);
}

function bothObjects(a, b) {
  return typeof a === 'object' && a !== null && typeof b === 'object' && b !== null;
}

function equalProps(a, b) {
  const keysOfA = Object.keys(a);
  const keysOfB = Object.keys(b);
  if (keysOfA.length !== keysOfB.length) return false;

  for (let i = 0; i < keysOfA.length; i++) {
    const key = keysOfA[i];
    if (!b.hasOwnProperty(key) || a[key] !== b[key]) return false;
  }

  return true;
}